//: C08:CheckedCast.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Kontroluje přetypování za běhu.
#include <iostream>
#include <vector>
#include "../purge.h"
using namespace std;

class Ceniny {
protected:
  enum { ZAKLADNIID = 0 };
public:
  virtual ~Ceniny() {}
  virtual bool isA(int id) { return (id == ZAKLADNIID); }
};

class Akcie : public Ceniny {
  typedef Ceniny Super;
protected:
  enum { OFFSET = 1, IDTYPU = ZAKLADNIID + OFFSET };
public:
  bool isA(int id) {
    return id == IDTYPU || Super::isA(id);
  }
  static Akcie* dynacast(Ceniny* s) {
    return (s->isA(IDTYPU)) ? static_cast<Akcie*>(s) : 0;
  }
};

class Obligace : public Ceniny {
  typedef Ceniny Super;
protected:
  enum { OFFSET = 2, IDTYPU = ZAKLADNIID + OFFSET };
public:
  bool isA(int id) {
    return id == IDTYPU || Super::isA(id);
  }
  static Obligace* dynacast(Ceniny* s) {
    return (s->isA(IDTYPU)) ? static_cast<Obligace*>(s) : 0;
  }
};

class Investice : public Ceniny {
  typedef Ceniny Super;
protected:
  enum { OFFSET = 3, IDTYPU = ZAKLADNIID + OFFSET };
public:
  bool isA(int id) {
    return id == IDTYPU || Super::isA(id);
  }
  static Investice* dynacast(Ceniny* s) {
    return (s->isA(IDTYPU)) ?
      static_cast<Investice*>(s) : 0;
  }
  void special() {
    cout << "Zvláštní investiční funkce" << endl;
  }
};

class Kov : public Investice {
  typedef Investice Super;
protected:
  enum { OFFSET = 4, IDTYPU = ZAKLADNIID + OFFSET };
public:
  bool isA(int id) {
    return id == IDTYPU || Super::isA(id);
  }
  static Kov* dynacast(Ceniny* s) {
    return (s->isA(IDTYPU)) ? static_cast<Kov*>(s) : 0;
  }
};

int main() {
  vector<Ceniny*> portfolio;
  portfolio.push_back(new Kov);
  portfolio.push_back(new Investice);
  portfolio.push_back(new Obligace);
  portfolio.push_back(new Akcie);
  for(vector<Ceniny*>::iterator it = portfolio.begin();
       it != portfolio.end(); ++it) {
    Investice* cm = Investice::dynacast(*it);
    if(cm)
      cm->special();
    else
      cout << "nejde o investici" << endl;
  }
  cout << "přetypování z mezilehlého ukazatele:" << endl;
  Ceniny* sp = new Kov;
  Investice* cp = Investice::dynacast(sp);
  if(cp) cout << "  je to Investice" << endl;
  Kov* mp = Kov::dynacast(sp);
  if(mp) cout << "  Je to i Kov!" << endl;
  purge(portfolio);
} ///:~
